## libgc 7.6.4

=== tests/CMakeLists.txt ===
#
# Copyright (c) 1994 by Xerox Corporation.  All rights reserved.
# Copyright (c) 1996 by Silicon Graphics.  All rights reserved.
# Copyright (c) 1998 by Fergus Henderson.  All rights reserved.
# Copyright (c) 2000-2010 by Hewlett-Packard Company.  All rights reserved.
##
# THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY EXPRESSED
# OR IMPLIED.  ANY USE IS AT YOUR OWN RISK.
##
# Permission is hereby granted to use or copy this program
# for any purpose,  provided the above notices are retained on all copies.
# Permission to modify the code and to distribute modified code is granted,
# provided the above notices are retained, and a notice that the code was
# modified is included with the above copyright notice.
##

ADD_DEFINITIONS(-DGC_NOT_DLL)

ADD_EXECUTABLE(gctest WIN32 test.c)
TARGET_LINK_LIBRARIES(gctest gc-lib)
ADD_TEST(NAME gctest COMMAND gctest)

ADD_EXECUTABLE(hugetest huge_test.c)
TARGET_LINK_LIBRARIES(hugetest gc-lib)
ADD_TEST(NAME hugetest COMMAND hugetest)

ADD_EXECUTABLE(leaktest leak_test.c)
TARGET_LINK_LIBRARIES(leaktest gc-lib)
ADD_TEST(NAME leaktest COMMAND leaktest)

ADD_EXECUTABLE(middletest middle.c)
TARGET_LINK_LIBRARIES(middletest gc-lib)
ADD_TEST(NAME middletest COMMAND middletest)

ADD_EXECUTABLE(realloc_test realloc_test.c)
TARGET_LINK_LIBRARIES(realloc_test gc-lib)
ADD_TEST(NAME realloc_test COMMAND realloc_test)

ADD_EXECUTABLE(smashtest smash_test.c)
TARGET_LINK_LIBRARIES(smashtest gc-lib)
ADD_TEST(NAME smashtest COMMAND smashtest)

=== debian/changelog ===
libgc (1:7.6.4-0.4ubuntu1) focal; urgency=medium

  * debian/patches/riscv64.diff: Add back riscv64 support, NMUed but later
    dropped.
  * Update symbols for riscv64.

 -- William Grant <wgrant@ubuntu.com>  Sun, 05 Apr 2020 18:43:00 +1000

libgc (1:7.6.4-0.4build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 21 Mar 2020 13:28:08 +0100

libgc (1:7.6.4-0.4) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix symbols files for KFreeBSD.

 -- Matthias Klose <doko@debian.org>  Sun, 09 Sep 2018 15:25:27 +0200

libgc (1:7.6.4-0.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Update symbols files for various architectures.

 -- Matthias Klose <doko@debian.org>  Sun, 09 Sep 2018 13:58:06 +0200

libgc (1:7.6.4-0.2) experimental; urgency=medium

  * Non-maintainer upload.
  * Update symbols files for various architectures.

 -- Matthias Klose <doko@debian.org>  Sun, 09 Sep 2018 11:25:05 +0200

libgc (1:7.6.4-0.1) experimental; urgency=medium

  * Non-maintainer upload.
  * New upstream release.
  * Bump standards and debhelper versions.
  * Update watch file.

 -- Matthias Klose <doko@debian.org>  Sat, 08 Sep 2018 17:17:59 +0200

libgc (1:7.4.4-1) experimental; urgency=medium

  * New upstream release
  * Import fixes for CVE-2016-9427 (Integer overflow in GC_MALLOC_ATOMIC)
    from upstream 7.4 branch (Closes: #844771)
  * Disable fix-location-of-assembly-files.diff, included upstream

 -- Christoph Egger <christoph@debian.org>  Sun, 20 Nov 2016 13:59:24 +0100

libgc (1:7.4.2-8) unstable; urgency=medium

  * Fix symbols for nios (Closes: #822445), Thanks to Helmut for report
    + patch!

 -- Christoph Egger <christoph@debian.org>  Tue, 17 May 2016 16:31:02 +0200

libgc (1:7.4.2-7.4) unstable; urgency=medium

  * Non-maintainer upload.
  * Import symbols for alpha (Closes: #818356)
  * Import symbols for powerpcspe (Closes: #818608)

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Fri, 18 Mar 2016 17:18:10 +0100

=== debian/control ===
Source: libgc
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Christoph Egger <christoph@debian.org>
Uploaders: Debian GCC Maintainers <debian-gcc@lists.debian.org>
Section: libs
Priority: standard
Build-Depends: debhelper (>= 9),
 dh-autoreconf,
 libatomic-ops-dev (>= 7.6~),
 pkg-config,
 pkg-kde-tools
Standards-Version: 4.2.1
Homepage: http://www.hboehm.info/gc/
#Vcs-Git: git://anonscm.debian.org/collab-maint/libgc.git
#Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/libgc.git

Package: libgc1c2
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: libgc1
Replaces: libgc1, libgc1c3
Multi-Arch: same
Description: conservative garbage collector for C and C++
 Boehm-Demers-Weiser's GC is a garbage collecting storage allocator that is
 intended to be used as a plug-in replacement for C's malloc or C++'s new().
 .
 It allows you to allocate memory basically as you normally would without
 explicitly deallocating memory that is no longer useful. The collector
 automatically recycles memory when it determines that it can no longer be
 used.
 .
 This version of the collector is thread safe, has C++ support and uses the
 defaults for everything else. However, it does not work as a drop-in malloc(3)
 replacement.

Package: libgc-dev
Architecture: any
Priority: optional
Section: libdevel
Depends: ${misc:Depends}, libgc1c2 (= ${binary:Version}), libc-dev
Multi-Arch: same
Description: conservative garbage collector for C (development)
 Boehm-Demers-Weiser's GC is a garbage collecting storage allocator that is
 intended to be used as a plug-in replacement for C's malloc or C++'s new().
 .
 It allows you to allocate memory basically as you normally would without
 explicitly deallocating memory that is no longer useful. The collector
 automatically recycles memory when it determines that it can no longer be
 used.
 .
 This version of the collector is thread safe, has C++ support and uses the
 defaults for everything else. However, it does not work as a drop-in malloc(3)
 replacement.
 .
 This package is required to compile and link programs that use libgc1c2.

=== debian/rules ===
#!/usr/bin/make -f

DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_BUILD_ARCH ?=$(shell dpkg --print-architecture)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

LDFLAGS += -pthread

%:
	dh $@ --with pkgkde_symbolshelper,autoreconf

override_dh_auto_configure:
	[ ! -d libatomic_ops-1.2 ] || mv libatomic_ops-1.2 libatomic_ops-1.2.bak
	./configure \
		$(CONFIG_OPTS) \
		--enable-cplusplus \
		--disable-dependency-tracking \
		--with-tags=CXX \
		--prefix=/usr \
		--mandir=\$${prefix}/share/man \
		--sysconfdir=/etc \
		--localstatedir=/var/lib \
		--datadir=\$${prefix}/share/doc \
		--host=$(DEB_HOST_GNU_TYPE) \
		--build=$(DEB_BUILD_GNU_TYPE) \
		--libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH)

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_test:
	$(MAKE) check
endif

override_dh_install:
	install -D doc/gc.man debian/tmp/usr/share/man/man3/gc_malloc.3
	dh_install
	rm debian/libgc-dev/usr/share/doc/libgc1c2/README.environment

override_dh_auto_clean:
	[ -d libatomic_ops-1.2 ] || [ ! -d libatomic_ops-1.2.bak ] || mv libatomic_ops-1.2.bak libatomic_ops-1.2
	dh_auto_clean
	rm -rf autom4te.cache libatomic_ops atomic_ops_sysdeps.S atomic_ops.c

override_dh_installchangelogs:
	dh_installchangelogs ChangeLog

## libgc 8.0.4

=== debian/changelog ===
libgc (1:8.0.4-3) unstable; urgency=medium

  * Fix cross/native difference: explicitly disable usage of
    -latomic_ops. (Helmut Grohne). Closes: #966820.
  * Fix misaligned tlfs passed to AO_load on m68k. Closes: #968553, #971548.
  * Bump standards version.

 -- Matthias Klose <doko@debian.org>  Sun, 06 Dec 2020 12:44:00 +0100

libgc (1:8.0.4-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix symbols files for kfreebsd-*. (Closes: #968385)

 -- Christoph Berg <myon@debian.org>  Tue, 27 Oct 2020 14:32:21 +0100

libgc (1:8.0.4-2) unstable; urgency=medium

  * Fix missing libgc-dev -> libatomic-ops-dev dependency (Helmut Grohne).
    Closes: #966651.

 -- Matthias Klose <doko@debian.org>  Mon, 03 Aug 2020 18:53:35 +0200

libgc (1:8.0.4-1) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.

 -- Matthias Klose <doko@debian.org>  Wed, 22 Jul 2020 02:37:12 +0200

libgc (1:8.0.4-1~exp4) experimental; urgency=medium

  * Team upload.
  * Update symbols file for riscv64.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 17 Apr 2020 10:21:02 +0200

libgc (1:8.0.4-1~exp3) experimental; urgency=medium

  * Team upload.
  * Update symbols files.
  * Rename libgc1c2 to libgc1, some missing symbols.
  * Lower priority to optional.
  * Bump debhelper to v11.

 -- Matthias Klose <doko@debian.org>  Wed, 08 Apr 2020 12:48:04 +0200

libgc (1:8.0.4-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream version.
    - Missing symbols: GC_fault_handler_lock, GC_start_debugging,
      GC_store_debug_info, GC_unix_sbrk_get_mem.
  * Configure with --enable-static --enable-docs.
  * Bump standards version.

 -- Matthias Klose <doko@debian.org>  Sun, 05 Apr 2020 12:03:18 +0200

=== debian/control ===
--- 
+++ 
@@ -1,25 +1,23 @@
 Source: libgc
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Christoph Egger <christoph@debian.org>
+Maintainer: Christoph Egger <christoph@debian.org>
 Uploaders: Debian GCC Maintainers <debian-gcc@lists.debian.org>
 Section: libs
-Priority: standard
-Build-Depends: debhelper (>= 9),
- dh-autoreconf,
+Priority: optional
+Build-Depends: debhelper (>= 11),
  libatomic-ops-dev (>= 7.6~),
  pkg-config,
  pkg-kde-tools
-Standards-Version: 4.2.1
+Standards-Version: 4.5.1
 Homepage: http://www.hboehm.info/gc/
 #Vcs-Git: git://anonscm.debian.org/collab-maint/libgc.git
 #Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/libgc.git
 
-Package: libgc1c2
+Package: libgc1
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${misc:Depends}, ${shlibs:Depends}
-Conflicts: libgc1
-Replaces: libgc1, libgc1c3
+Conflicts: libgc1c2
+Replaces: libgc1c2
 Multi-Arch: same
 Description: conservative garbage collector for C and C++
  Boehm-Demers-Weiser's GC is a garbage collecting storage allocator that is
@@ -36,9 +34,8 @@
 
 Package: libgc-dev
 Architecture: any
-Priority: optional
 Section: libdevel
-Depends: ${misc:Depends}, libgc1c2 (= ${binary:Version}), libc-dev
+Depends: ${misc:Depends}, libgc1 (= ${binary:Version}), libc-dev, ${atomic:Depends}
 Multi-Arch: same
 Description: conservative garbage collector for C (development)
  Boehm-Demers-Weiser's GC is a garbage collecting storage allocator that is

=== debian/rules ===
--- 
+++ 
@@ -7,6 +7,10 @@
 
 LDFLAGS += -pthread
 
+ifneq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
+ATOMIC_BUILTIN_ARCHS = alpha amd64 arm64 armel armhf hppa hurd-i386 i386 ia64 kfreebsd-amd64 kfreebsd-i386 mips64el mipsel powerpc ppc64 ppc64el riscv64 s390x x32
+endif
+
 %:
 	dh $@ --with pkgkde_symbolshelper,autoreconf
 
@@ -15,6 +19,8 @@
 	./configure \
 		$(CONFIG_OPTS) \
 		--enable-cplusplus \
+		--enable-static \
+		--enable-docs \
 		--disable-dependency-tracking \
 		--with-tags=CXX \
 		--prefix=/usr \
@@ -24,7 +30,8 @@
 		--datadir=\$${prefix}/share/doc \
 		--host=$(DEB_HOST_GNU_TYPE) \
 		--build=$(DEB_BUILD_GNU_TYPE) \
-		--libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH)
+		--libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH) \
+		$(if $(filter $(DEB_HOST_ARCH),$(ATOMIC_BUILTIN_ARCHS)),--with-libatomic-ops=none)
 
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 override_dh_auto_test:
@@ -34,7 +41,7 @@
 override_dh_install:
 	install -D doc/gc.man debian/tmp/usr/share/man/man3/gc_malloc.3
 	dh_install
-	rm debian/libgc-dev/usr/share/doc/libgc1c2/README.environment
+	rm debian/libgc-dev/usr/share/doc/libgc1/README.environment
 
 override_dh_auto_clean:
 	[ -d libatomic_ops-1.2 ] || [ ! -d libatomic_ops-1.2.bak ] || mv libatomic_ops-1.2.bak libatomic_ops-1.2
@@ -43,3 +50,6 @@
 
 override_dh_installchangelogs:
 	dh_installchangelogs ChangeLog
+
+override_dh_gencontrol:
+	dh_gencontrol -- -Vatomic:Depends=$$(grep -q '[-]latomic_ops' debian/libgc-dev/usr/lib/*/pkgconfig/*.pc && echo libatomic-ops-dev)

=== debian/watch ===
version=3
opts="uversionmangle=s/_/./g" \
http://www.hboehm.info/gc/gc_source/ gc-(.*).tar.gz

## libgc 8.0.6

=== CMakeLists.txt ===
#
# Copyright (c) 1994 by Xerox Corporation.  All rights reserved.
# Copyright (c) 1996 by Silicon Graphics.  All rights reserved.
# Copyright (c) 1998 by Fergus Henderson.  All rights reserved.
# Copyright (c) 2000-2010 by Hewlett-Packard Company.  All rights reserved.
##
# THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY EXPRESSED
# OR IMPLIED.  ANY USE IS AT YOUR OWN RISK.
##
# Permission is hereby granted to use or copy this program
# for any purpose,  provided the above notices are retained on all copies.
# Permission to modify the code and to distribute modified code is granted,
# provided the above notices are retained, and a notice that the code was
# modified is included with the above copyright notice.
##

#
#  get cmake and run:
#    cmake -G "Visual Studio 8 2005"
#  in the same dir as this file
#  this will generate gc.sln
#

SET(CMAKE_LEGACY_CYGWIN_WIN32 0) # Remove when CMake >= 2.8.4 is required

PROJECT(gc)

INCLUDE(CTest)

CMAKE_MINIMUM_REQUIRED(VERSION 2.6)

ADD_DEFINITIONS("-D_CRT_SECURE_NO_DEPRECATE
                 -DALL_INTERIOR_POINTERS -DNO_EXECUTE_PERMISSION")

#LIBATOMIC #TODO
#ADD_LIBRARY(atomic_ops STATIC )
#SET_TARGET_PROPERTIES(atomic_ops PROPERTIES COMPILE_FLAGS -DNO_DEBUGGING)


#LIBGC

INCLUDE_DIRECTORIES(include)
INCLUDE_DIRECTORIES(libatomic_ops/src)

SET(SRC alloc.c reclaim.c allchblk.c misc.c mach_dep.c os_dep.c
        mark_rts.c headers.c mark.c obj_map.c blacklst.c finalize.c
        new_hblk.c dbg_mlc.c malloc.c dyn_load.c typd_mlc.c ptr_chck.c
        mallocx.c)
SET(LIBS)
OPTION(enable_threads "TODO" NO)
IF(enable_threads)
        FIND_PACKAGE(Threads REQUIRED)
        MESSAGE("Thread Model: ${CMAKE_THREAD_LIBS_INIT}" )
        INCLUDE_DIRECTORIES(${Threads_INCLUDE_DIR})
        SET(LIBS ${LIBS} ${Threads_LIBRARIES})
ENDIF(enable_threads)

OPTION(enable_handle_fork "Attempt to ensure a usable collector after fork()" ON)

OPTION(enable_thread_local_alloc "Turn on thread-local allocation optimization" ON)

OPTION(enable_parallel_mark "Parallelize marking and free list construction" ON)

#IF(Threads_FOUND)
#       ADD_DEFINITIONS("")
#ELSE
#       MESSAGE("Parallel mark requires enable_threads ON" )
#ENDIF(Threads_FOUND)

#OPTION(enable_cplusplus "install C++ support" ON)
SET(SRC ${SRC} gc_cpp.cc)

SET(_HOST ${CMAKE_HOST_SYSTEM_PROCESSOR}--${CMAKE_SYSTEM}) #FIXME missing the vendor field.
STRING(TOLOWER ${_HOST} HOST)
MESSAGE("HOST = ${HOST}")

# Thread Detection.  Relying on cmake for lib and includes.
#TODO check cmake detection
IF(CMAKE_USE_PTHREADS_INIT)
        SET(SRC ${SRC} gc_dlopen.c pthread_start.c pthread_stop_world.c
                pthread_support.c)
        # Common defines for most POSIX platforms.
        IF( HOST MATCHES .*-.*-aix.*|.*-.*-android.*|.*-.*-cygwin.*|.*-.*-darwin.*|.*-.*-.*freebsd.*|.*-.*-haiku.*|.*-.*-gnu.*|.*-.*-hpux11.*|.*-.*-irix.*|.*-.*-.*linux.*|.*-.*-msys.*|.*-.*-nacl.*|.*-.*-netbsd.*|.*-.*-openbsd.*|.*-.*-osf.*|.*-.*-solaris.*)
                ADD_DEFINITIONS("-DGC_THREADS -D_REENTRANT")
                IF(enable_parallel_mark)
                    ADD_DEFINITIONS("-DPARALLEL_MARK")
                ENDIF(enable_parallel_mark)
                IF(enable_thread_local_alloc)
                    ADD_DEFINITIONS("-DTHREAD_LOCAL_ALLOC")
                    SET(SRC ${SRC} specific.c thread_local_alloc.c)
                ENDIF(enable_thread_local_alloc)
                MESSAGE("Explicit GC_INIT() calls may be required.")
        ENDIF()
        IF ( HOST MATCHES .*-.*-hpux11.*)
                MESSAGE("Only HP/UX 11 POSIX threads are supported.")
                ADD_DEFINITIONS("-D_POSIX_C_SOURCE=199506L") #TODO test -DVAR=value. Alternative is COMPILE_DEFINITIONS property
        ENDIF()
        IF ( HOST MATCHES .*-.*-hpux10.*)
                MESSAGE("HP/UX 10 POSIX threads are not supported.")
        ENDIF()
        IF ( HOST MATCHES .*-.*-netbsd.*)
                MESSAGE("Only on NetBSD 2.0 or later.")
                ADD_DEFINITIONS("-D_PTHREADS")
        ENDIF()
        IF( HOST MATCHES .*-.*-android.*)
                # Android NDK does not provide pthread_atfork.
        ELSEIF( HOST MATCHES .*-.*-aix.*|.*-.*-cygwin.*|.*-.*-freebsd.*|.*-.*-haiku.*|.*-.*-hpux11.*|.*-.*-irix.*|.*-.*-kfreebsd.*-gnu|.*-.*-.*linux.*|.*-.*-netbsd.*|.*-.*-openbsd.*|.*-.*-osf.*|.*-.*-solaris.*)
                IF(enable_handle_fork)
                    ADD_DEFINITIONS("-DHANDLE_FORK")
                ENDIF(enable_handle_fork)
        ENDIF()
        IF ( HOST MATCHES .*-.*-cygwin.*|.*-.*-msys.*)
                SET(SRC ${SRC} win32_threads.c)
        ENDIF()
        IF ( HOST MATCHES .*-.*-darwin.*)
                IF(enable_handle_fork)
                    # The incremental mode conflicts with fork handling.
                    IF(enable_parallel_mark)
                        ADD_DEFINITIONS("-DHANDLE_FORK")
                    ENDIF(enable_parallel_mark)
                ENDIF(enable_handle_fork)
                SET(SRC ${SRC} darwin_stop_world.c)
                #TODO
                #darwin_threads=true
        ENDIF()
ENDIF(CMAKE_USE_PTHREADS_INIT)

IF(CMAKE_USE_WIN32_THREADS_INIT)
        ADD_DEFINITIONS("-DGC_THREADS")
        IF(enable_parallel_mark)
                ADD_DEFINITIONS("-DPARALLEL_MARK")
                IF(enable_thread_local_alloc)
                    ADD_DEFINITIONS("-DTHREAD_LOCAL_ALLOC")
                    SET(SRC ${SRC} thread_local_alloc.c)
                ENDIF(enable_thread_local_alloc)
        ENDIF()
        ADD_DEFINITIONS("-DEMPTY_GETENV_RESULTS") #TODO test
        SET(SRC ${SRC} win32_threads.c)
ENDIF(CMAKE_USE_WIN32_THREADS_INIT)

OPTION(enable_gcj_support "Support for gcj" ON)
IF(enable_gcj_support)
        ADD_DEFINITIONS("-DGC_GCJ_SUPPORT")
        IF(enable_threads)
                ADD_DEFINITIONS("-DGC_ENABLE_SUSPEND_THREAD")
        ENDIF(enable_threads)
        SET(SRC ${SRC} gcj_mlc.c)
ENDIF(enable_gcj_support)

OPTION(enable_disclaim "Support alternative finalization interface" ON)
IF(enable_disclaim)
    ADD_DEFINITIONS("-DENABLE_DISCLAIM")
    SET(SRC ${SRC} fnlz_mlc.c)
ENDIF(enable_disclaim)

OPTION(enable_java_finalization "Support for java finalization" ON)
IF(enable_java_finalization)
    ADD_DEFINITIONS("-DJAVA_FINALIZATION")
ENDIF(enable_java_finalization)

OPTION(enable_atomic_uncollectable "Support for atomic uncollectible allocation" ON)
IF(enable_atomic_uncollectable)
    ADD_DEFINITIONS("-DGC_ATOMIC_UNCOLLECTABLE")
ENDIF(enable_atomic_uncollectable)

OPTION(enable_gc_debug "Support for pointer back-tracing" NO)
IF(enable_gc_debug)
    ADD_DEFINITIONS("-DDBG_HDRS_ALL -DKEEP_BACK_PTRS")
    IF (HOST MATCHES ia64-.*-linux.*|i586-.*-linux.*|i686-.*-linux.*|x86-.*-linux.*|x86_64-.*-linux.*)
        ADD_DEFINITIONS("-DMAKE_BACK_GRAPH")
        ADD_DEFINITIONS("-DSAVE_CALL_COUNT=8")
        SET(SRC ${SRC} backgraph.c)
    ENDIF()
    IF (HOST MATCHES i.86-.*-dgux.*)
        ADD_DEFINITIONS("-DMAKE_BACK_GRAPH")
        SET(SRC ${SRC} backgraph.c)
    ENDIF()
ENDIF(enable_gc_debug)

OPTION(enable_redirect_malloc "Redirect malloc and friends to GC routines" NO)
IF(enable_redirect_malloc)
    IF(enable_gc_debug)
        ADD_DEFINITIONS("-DREDIRECT_MALLOC=GC_debug_malloc_replacement")
        ADD_DEFINITIONS("-DREDIRECT_REALLOC=GC_debug_realloc_replacement")
        ADD_DEFINITIONS("-DREDIRECT_FREE=GC_debug_free")
    ELSE(enable_gc_debug)
        ADD_DEFINITIONS("-DREDIRECT_MALLOC=GC_malloc")
    ENDIF(enable_gc_debug)
    ADD_DEFINITIONS("-DGC_USE_DLOPEN_WRAP")
ENDIF(enable_redirect_malloc)

OPTION(enable_mmap "Use mmap instead of sbrk to expand the heap" NO)

OPTION(enable_munmap "Return page to the OS if empty for N collections" ON)
IF(enable_munmap)
    ADD_DEFINITIONS("-DUSE_MMAP -DUSE_MUNMAP")
ELSEIF(enable_mmap)
    ADD_DEFINITIONS("-DUSE_MMAP")
ENDIF()

OPTION(enable_dynamic_loading "Enable tracing of dynamic library data roots" ON)
IF(NOT enable_dynamic_loading)
    ADD_DEFINITIONS("-DIGNORE_DYNAMIC_LOADING")
ENDIF()

OPTION(enable_register_main_static_data "Perform the initial guess of data root sets" ON)
IF(NOT enable_register_main_static_data)
    ADD_DEFINITIONS("-DGC_DONT_REGISTER_MAIN_STATIC_DATA")
ENDIF()

OPTION(enable_large_config "Optimize for large heap or root set" NO)
IF(enable_large_config)
    ADD_DEFINITIONS("-DLARGE_CONFIG")
ENDIF(enable_large_config)

OPTION(enable_gc_assertions "Enable collector-internal assertion checking" NO)
IF(enable_gc_assertions)
    ADD_DEFINITIONS("-DGC_ASSERTIONS")
ENDIF(enable_gc_assertions)

OPTION(enable_threads_discovery "Enable threads discovery in GC" ON)
IF(NOT enable_threads_discovery)
    ADD_DEFINITIONS("-DGC_NO_THREADS_DISCOVERY")
ENDIF()

OPTION(enable_checksums "Report erroneously cleared dirty bits" NO)
IF(enable_checksums)
    IF(enable_munmap OR enable_threads)
        MESSAGE("CHECKSUMS not compatible with USE_MUNMAP or threads")
    ENDIF()
    ADD_DEFINITIONS("-DCHECKSUMS")
    SET(SRC ${SRC} checksums.c)
ENDIF(enable_checksums)

ADD_LIBRARY(          gc-lib   STATIC      ${SRC})
SET_TARGET_PROPERTIES(gc-lib   PROPERTIES
                      COMPILE_DEFINITIONS GC_NOT_DLL)
#TODO TARGET_LINK_LIBRARIES(...  ...  ${LIBS})

ADD_LIBRARY(          gcmt-dll  SHARED     ${SRC})

IF(WIN32)
  ADD_EXECUTABLE(cord cord/cordbscs.c cord/cordxtra.c
                 cord/tests/de.c cord/tests/de_win.c)
  SET_TARGET_PROPERTIES(cord PROPERTIES WIN32_EXECUTABLE TRUE)
  SET_TARGET_PROPERTIES(cord    PROPERTIES
                      COMPILE_DEFINITIONS GC_NOT_DLL)
  TARGET_LINK_LIBRARIES(cord gc-lib)
  TARGET_LINK_LIBRARIES(cord gdi32)
ENDIF(WIN32)

ADD_SUBDIRECTORY(tests)

=== debian/changelog ===
libgc (1:8.0.6-1.1build1) jammy; urgency=high

  * No change rebuild for ppc64el baseline bump.

 -- Julian Andres Klode <juliank@ubuntu.com>  Thu, 24 Mar 2022 13:12:16 +0100

libgc (1:8.0.6-1.1) unstable; urgency=medium

  * Non-maintainer upload. ((Closes: #999740)
  * New upstream version 8.0.6
  * Update to point to salsa
  * Update symbols for 8.0.6
  * Drop enable-threads-on-hurd.diff and issue329.diff

 -- Ian Wienand <ianw@debian.org>  Fri, 26 Nov 2021 09:12:33 +1100

libgc (1:8.0.4-3+alpha.1) unreleased; urgency=medium

  * Update symbols on Alpha (fixing FTBFS).

 -- Michael Cree <mcree@orcon.net.nz>  Fri, 26 Mar 2021 08:19:12 +1300

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Source: libgc
-Maintainer: Christoph Egger <christoph@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Christoph Egger <christoph@debian.org>
 Uploaders: Debian GCC Maintainers <debian-gcc@lists.debian.org>
 Section: libs
 Priority: optional
@@ -9,8 +10,7 @@
  pkg-kde-tools
 Standards-Version: 4.5.1
 Homepage: http://www.hboehm.info/gc/
-#Vcs-Git: git://anonscm.debian.org/collab-maint/libgc.git
-#Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/libgc.git
+Vcs-Git: https://salsa.debian.org/debian/libgc
 
 Package: libgc1
 Architecture: any

## libgc 8.2.2

=== debian/changelog ===
libgc (1:8.2.2-3) unstable; urgency=medium

  * Fix pthread symbol exports for hurd/kfreebsd
  * Demangle C++ names in symbols file

 -- Ian Wienand <ianw@debian.org>  Tue, 06 Sep 2022 18:30:14 +1000

libgc (1:8.2.2-2) unstable; urgency=medium

  * Remove libatomic_ops as a build-dep;
    remove matching from build to simplify future
    porting.
  * libgccpp.so.1 : add back differing 32-bit C++ symbols
    (Closes: #1018924)


 -- Ian Wienand <ianw@debian.org>  Mon, 05 Sep 2022 21:17:49 +1000

libgc (1:8.2.2-1) unstable; urgency=medium

  * Update watch/control upstream links to https
  * libgc-dev: remove duplicate doc copy
  * Remove libatomic_ops handling
  * Add .gitignore
  * Build static and dynamic separately
  * Use common config options for static/dynamic
  * Update debian/watch to github source
  * Add ianw@debian.org as uploader
  * New upstream version 8.2.2
  * Update watch/control upstream links to https
  * libgc-dev: remove duplicate doc copy
  * Remove libatomic_ops handling
  * Add .gitignore
  * Build static and dynamic separately
  * Use common config options for static/dynamic
  * Update debian/watch to github source
  * Add ianw@debian.org as uploader
  * New upstream version 8.2.2
  * Update symbols file for 8.2.2

 -- Ian Wienand <ianw@debian.org>  Wed, 31 Aug 2022 15:11:15 +1000

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,13 @@
 Source: libgc
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Christoph Egger <christoph@debian.org>
-Uploaders: Debian GCC Maintainers <debian-gcc@lists.debian.org>
+Maintainer: Christoph Egger <christoph@debian.org>
+Uploaders: Debian GCC Maintainers <debian-gcc@lists.debian.org>, Ian Wienand <ianw@debian.org>
 Section: libs
 Priority: optional
 Build-Depends: debhelper (>= 11),
- libatomic-ops-dev (>= 7.6~),
  pkg-config,
  pkg-kde-tools
 Standards-Version: 4.5.1
-Homepage: http://www.hboehm.info/gc/
+Homepage: https://www.hboehm.info/gc/
 Vcs-Git: https://salsa.debian.org/debian/libgc
 
 Package: libgc1
@@ -35,7 +33,7 @@
 Package: libgc-dev
 Architecture: any
 Section: libdevel
-Depends: ${misc:Depends}, libgc1 (= ${binary:Version}), libc-dev, ${atomic:Depends}
+Depends: ${misc:Depends}, libgc1 (= ${binary:Version}), libc-dev
 Multi-Arch: same
 Description: conservative garbage collector for C (development)
  Boehm-Demers-Weiser's GC is a garbage collecting storage allocator that is

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*@ARCHIVE_EXT@)%@PACKAGE@-$1%" \
      https://github.com/ivmai/bdwgc/releases \
      (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@

## libgc 8.2.4

=== debian/changelog ===
libgc (1:8.2.4-1deepin1) unstable; urgency=medium

  * add sw64 porting (from previous version)

 -- Chang Yang <yangchang@deepin.org>  Fri, 01 Dec 2023 17:45:47 +0800

libgc (1:8.2.4-1) unstable; urgency=medium

  * New upstream version 8.2.4
  * Add GC_<get|set>_sp_corrector symbols

 -- Ian Wienand <ianw@debian.org>  Wed, 31 May 2023 22:05:34 +1000

## libgc 8.2.6

=== CMakeLists.txt ===
#
# Copyright (c) 1994 by Xerox Corporation.  All rights reserved.
# Copyright (c) 1996 by Silicon Graphics.  All rights reserved.
# Copyright (c) 1998 by Fergus Henderson.  All rights reserved.
# Copyright (c) 2000-2010 by Hewlett-Packard Company.  All rights reserved.
# Copyright (c) 2010-2021 Ivan Maidanski
##
# THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY EXPRESSED
# OR IMPLIED.  ANY USE IS AT YOUR OWN RISK.
##
# Permission is hereby granted to use or copy this program
# for any purpose,  provided the above notices are retained on all copies.
# Permission to modify the code and to distribute modified code is granted,
# provided the above notices are retained, and a notice that the code was
# modified is included with the above copyright notice.
##

#
#  get cmake and run:
#    cmake -G "Visual Studio 8 2005"
#  in the same dir as this file
#  this will generate gc.sln
#

cmake_minimum_required(VERSION 3.5)

set(PACKAGE_VERSION 8.2.6)
# Version must match that in AC_INIT of configure.ac and that in README.
# Version must conform to: [0-9]+[.][0-9]+[.][0-9]+

# Info (current:revision:age) for the Libtool versioning system.
# These values should match those in cord/cord.am and Makefile.am.
set(LIBCORD_VER_INFO    6:1:5)
set(LIBGC_VER_INFO      6:3:5)
set(LIBGCCPP_VER_INFO   6:0:5)

option(enable_cplusplus "C++ support" OFF)
if (enable_cplusplus)
  project(gc)
else()
  project(gc C)
endif()

if (POLICY CMP0057)
  # Required for CheckLinkerFlag, at least.
  cmake_policy(SET CMP0057 NEW)
endif()

include(CheckCCompilerFlag)
include(CheckCSourceCompiles)
include(CheckFunctionExists)
include(CheckIncludeFile)
include(CheckSymbolExists)
include(CMakePackageConfigHelpers)
include(CTest)
include(GNUInstallDirs)

if (NOT (${CMAKE_VERSION} VERSION_LESS "3.18.0"))
  include(CheckLinkerFlag)
endif()

# Customize the build by passing "-D<option_name>=ON|OFF" in the command line.
option(BUILD_SHARED_LIBS "Build shared libraries" ON)
option(build_cord "Build cord library" ON)
option(build_tests "Build tests" OFF)
option(enable_docs "Build and install documentation" ON)
option(enable_threads "Support threads" ON)
option(enable_parallel_mark "Parallelize marking and free list construction" ON)
option(enable_thread_local_alloc "Turn on thread-local allocation optimization" ON)
option(enable_threads_discovery "Enable threads discovery in GC" ON)
option(enable_throw_bad_alloc_library "Turn on C++ gctba library build" ON)
option(enable_gcj_support "Support for gcj" ON)
option(enable_sigrt_signals "Use SIGRTMIN-based signals for thread suspend/resume" OFF)
option(enable_gc_debug "Support for pointer back-tracing" OFF)
option(disable_gc_debug "Disable debugging like GC_dump and its callees" OFF)
option(enable_java_finalization "Support for java finalization" ON)
option(enable_atomic_uncollectable "Support for atomic uncollectible allocation" ON)
option(enable_redirect_malloc "Redirect malloc and friends to GC routines" OFF)
option(enable_disclaim "Support alternative finalization interface" ON)
option(enable_large_config "Optimize for large heap or root set" OFF)
option(enable_gc_assertions "Enable collector-internal assertion checking" OFF)
option(enable_mmap "Use mmap instead of sbrk to expand the heap" OFF)
option(enable_munmap "Return page to the OS if empty for N collections" ON)
option(enable_dynamic_loading "Enable tracing of dynamic library data roots" ON)
option(enable_register_main_static_data "Perform the initial guess of data root sets" ON)
option(enable_checksums "Report erroneously cleared dirty bits" OFF)
option(enable_werror "Pass -Werror to the C compiler (treat warnings as errors)" OFF)
option(enable_single_obj_compilation "Compile all libgc source files into single .o" OFF)
option(enable_handle_fork "Attempt to ensure a usable collector after fork()" ON)
option(disable_handle_fork "Prohibit installation of pthread_atfork() handlers" OFF)
option(enable_emscripten_asyncify "Use Emscripten asyncify feature" OFF)
option(install_headers "Install header and pkg-config metadata files" ON)
option(without_libatomic_ops "Use atomic_ops.h in libatomic_ops/src" OFF)

# Override the default build type to RelWithDebInfo (this instructs cmake to
# pass -O2 -g -DNDEBUG options to the compiler by default).
if (NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE
      STRING "Choose the type of build." FORCE)
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY
               STRINGS "Debug" "Release" "RelWithDebInfo" "MinSizeRel")
endif()

# Convert VER_INFO values to [SO]VERSION ones.
if (BUILD_SHARED_LIBS)
  # cord:
  string(REGEX REPLACE "(.+):.+:.+"  "\\1" cord_cur ${LIBCORD_VER_INFO})
  string(REGEX REPLACE ".+:(.+):.+"  "\\1" cord_rev ${LIBCORD_VER_INFO})
  string(REGEX REPLACE ".+:.+:(.+)$" "\\1" cord_age ${LIBCORD_VER_INFO})
  math(EXPR CORD_SOVERSION "${cord_cur} - ${cord_age}")
  set(CORD_VERSION_PROP "${CORD_SOVERSION}.${cord_age}.${cord_rev}")
  message(STATUS "CORD_VERSION_PROP = ${CORD_VERSION_PROP}")
  # gc:
  string(REGEX REPLACE "(.+):.+:.+"  "\\1" gc_cur ${LIBGC_VER_INFO})
  string(REGEX REPLACE ".+:(.+):.+"  "\\1" gc_rev ${LIBGC_VER_INFO})
  string(REGEX REPLACE ".+:.+:(.+)$" "\\1" gc_age ${LIBGC_VER_INFO})
  math(EXPR GC_SOVERSION "${gc_cur} - ${gc_age}")
  set(GC_VERSION_PROP "${GC_SOVERSION}.${gc_age}.${gc_rev}")
  message(STATUS "GC_VERSION_PROP = ${GC_VERSION_PROP}")
  # gccpp and gctba:
  string(REGEX REPLACE "(.+):.+:.+"  "\\1" gccpp_cur ${LIBGCCPP_VER_INFO})
  string(REGEX REPLACE ".+:(.+):.+"  "\\1" gccpp_rev ${LIBGCCPP_VER_INFO})
  string(REGEX REPLACE ".+:.+:(.+)$" "\\1" gccpp_age ${LIBGCCPP_VER_INFO})
  math(EXPR GCCPP_SOVERSION "${gccpp_cur} - ${gccpp_age}")
  set(GCCPP_VERSION_PROP "${GCCPP_SOVERSION}.${gccpp_age}.${gccpp_rev}")
  message(STATUS "GCCPP_VERSION_PROP = ${GCCPP_VERSION_PROP}")
endif(BUILD_SHARED_LIBS)

add_definitions("-DALL_INTERIOR_POINTERS -DNO_EXECUTE_PERMISSION")

# Set struct packing alignment to word (instead of 1-byte).
if (BORLAND)
  add_compile_options(/a4)
elseif (WATCOM)
  add_compile_options(/zp4)
endif()

# Output all warnings.
if (BORLAND)
  # All warnings except for particular ones.
  add_compile_options(/w /w-pro /w-aus /w-par /w-ccc /w-inl /w-rch)
elseif (MSVC)
  # All warnings but ignoring "unreferenced formal parameter" and
  # "conditional expression is constant" ones.
  add_compile_options(/W4 /wd4100 /wd4127)
elseif (WATCOM)
  add_compile_options(/wx)
  if (NOT enable_threads)
    # Suppress "unreachable code" warning in GC_ASSERT(I_HOLD_LOCK()).
    add_compile_options(/wcd=201)
  endif()
else()
  # TODO add -[W]pedantic -Wno-long-long
  add_compile_options(-Wall -Wextra)
endif()

if (WIN32)
  # Disable MS crt security warnings reported e.g. for getenv, strcpy.
  add_definitions("-D_CRT_SECURE_NO_DEPRECATE")
endif()

include_directories(include)

set(SRC alloc.c reclaim.c allchblk.c misc.c mach_dep.c os_dep.c
        mark_rts.c headers.c mark.c obj_map.c blacklst.c finalize.c
        new_hblk.c dbg_mlc.c malloc.c dyn_load.c typd_mlc.c ptr_chck.c
        mallocx.c)
set(THREADDLLIBS_LIST)
set(NEED_LIB_RT)

set(_HOST ${CMAKE_SYSTEM_PROCESSOR}-unknown-${CMAKE_SYSTEM})
string(TOLOWER ${_HOST} HOST)
message(STATUS "TARGET = ${HOST}")

if (enable_threads)
  find_package(Threads REQUIRED)
  message(STATUS "Thread library: ${CMAKE_THREAD_LIBS_INIT}")
  if (without_libatomic_ops OR BORLAND OR MSVC OR WATCOM)
    include_directories(libatomic_ops/src)
    # Note: alternatively, use CFLAGS_EXTRA to pass -I<...>/libatomic_ops/src.
  else()
    # Assume the compiler supports GCC atomic intrinsics.
    add_definitions("-DGC_BUILTIN_ATOMIC")
  endif()
  include_directories(${Threads_INCLUDE_DIR})
  set(THREADDLLIBS_LIST ${CMAKE_THREAD_LIBS_INIT})
  if (${CMAKE_DL_LIBS} MATCHES ^[^-].*)
    # Some cmake versions have a broken non-empty CMAKE_DL_LIBS omitting "-l".
    # Assume CMAKE_DL_LIBS contains just one library.
    set(THREADDLLIBS_LIST ${THREADDLLIBS_LIST} -l${CMAKE_DL_LIBS})
  else()
    set(THREADDLLIBS_LIST ${THREADDLLIBS_LIST} ${CMAKE_DL_LIBS})
  endif()
endif(enable_threads)

set(ATOMIC_OPS_LIBS "") # TODO: Assume libatomic_ops library is not needed.

# Thread support detection.
if (CMAKE_USE_PTHREADS_INIT)
  set(SRC ${SRC} gc_dlopen.c)
  if (CYGWIN OR WIN32)
    set(SRC ${SRC} win32_threads.c)
  else()
    set(SRC ${SRC} pthread_start.c pthread_stop_world.c pthread_support.c)
  endif()
  if (APPLE)
    set(SRC ${SRC} darwin_stop_world.c)
  endif()
  if (HOST MATCHES .*-.*-hpux10.*)
    message(FATAL_ERROR "HP/UX 10 POSIX threads are not supported.")
  endif()
  # Common defines for POSIX platforms.
  add_definitions("-DGC_THREADS -D_REENTRANT")
  if (enable_parallel_mark)
    add_definitions("-DPARALLEL_MARK")
  endif()
  if (enable_thread_local_alloc)
    add_definitions("-DTHREAD_LOCAL_ALLOC")
    set(SRC ${SRC} specific.c thread_local_alloc.c)
  endif()
  message("Explicit GC_INIT() calls may be required.")
  if (HOST MATCHES .*-.*-hpux11.*)
    message("Only HP/UX 11 POSIX threads are supported.")
    add_definitions("-D_POSIX_C_SOURCE=199506L")
    set(NEED_LIB_RT ON)
  elseif (HOST MATCHES .*-.*-netbsd.*)
    message("Only on NetBSD 2.0 or later.")
    add_definitions("-D_PTHREADS")
    set(NEED_LIB_RT ON)
  endif()
  if (WIN32) # AND NOT CYGWIN
    # Does not provide process fork functionality.
  elseif (enable_handle_fork AND NOT disable_handle_fork)
    add_definitions("-DHANDLE_FORK")
  endif()
  if (enable_sigrt_signals)
    add_definitions("-DGC_USESIGRT_SIGNALS")
  endif()
elseif (CMAKE_USE_WIN32_THREADS_INIT)
  add_definitions("-DGC_THREADS")
  if (enable_parallel_mark)
    add_definitions("-DPARALLEL_MARK")
  endif()
  if (enable_thread_local_alloc AND (enable_parallel_mark OR NOT BUILD_SHARED_LIBS))
    # Imply THREAD_LOCAL_ALLOC unless GC_DLL.
    add_definitions("-DTHREAD_LOCAL_ALLOC")
    set(SRC ${SRC} thread_local_alloc.c)
  endif()
  add_definitions("-DEMPTY_GETENV_RESULTS")
  set(SRC ${SRC} win32_threads.c)
elseif (CMAKE_HP_PTHREADS_INIT OR CMAKE_USE_SPROC_INIT)
  message(FATAL_ERROR "Unsupported thread package")
endif()

# Check whether -lrt linker option is needed to use clock_gettime.
if (NOT NEED_LIB_RT)
  check_function_exists(clock_gettime HAVE_CLOCK_GETTIME_DIRECTLY)
  if (NOT HAVE_CLOCK_GETTIME_DIRECTLY)
    # Use of clock_gettime() probably requires linking with "rt" library.
    set(NEED_LIB_RT ON)
  endif()
endif()

# Locate and use "rt" library if needed (and the library is available).
if (NEED_LIB_RT)
  find_library(LIBRT rt)
  if (LIBRT)
    set(THREADDLLIBS_LIST ${THREADDLLIBS_LIST} ${LIBRT})
  endif()
endif(NEED_LIB_RT)

if (disable_handle_fork)
  add_definitions("-DNO_HANDLE_FORK")
endif()

if (enable_gcj_support)
  add_definitions("-DGC_GCJ_SUPPORT")
  if (enable_threads AND NOT (enable_thread_local_alloc AND HOST MATCHES .*-.*-kfreebsd.*-gnu))
    # FIXME: For a reason, gctest hangs up on kFreeBSD if both of
    # THREAD_LOCAL_ALLOC and GC_ENABLE_SUSPEND_THREAD are defined.
    add_definitions("-DGC_ENABLE_SUSPEND_THREAD")
  endif()
  set(SRC ${SRC} gcj_mlc.c)
endif(enable_gcj_support)

if (enable_disclaim)
  add_definitions("-DENABLE_DISCLAIM")
  set(SRC ${SRC} fnlz_mlc.c)
endif()

if (enable_java_finalization)
  add_definitions("-DJAVA_FINALIZATION")
endif()

if (enable_atomic_uncollectable)
  add_definitions("-DGC_ATOMIC_UNCOLLECTABLE")
endif()

if (enable_gc_debug)
  add_definitions("-DDBG_HDRS_ALL -DKEEP_BACK_PTRS")
  if (HOST MATCHES i.86-.*-dgux.*|ia64-.*-linux.*|i586-.*-linux.*|i686-.*-linux.*|x86-.*-linux.*|x86_64-.*-linux.*)
    add_definitions("-DMAKE_BACK_GRAPH")
    if (HOST MATCHES .*-.*-.*linux.*)
      add_definitions("-DSAVE_CALL_COUNT=8")
    endif()
    set(SRC ${SRC} backgraph.c)
  endif()
endif(enable_gc_debug)

if (disable_gc_debug)
  add_definitions("-DNO_DEBUGGING")
elseif (WINCE)
  # Read environment variables from "<program>.gc.env" file.
  add_definitions("-DGC_READ_ENV_FILE")
endif()

=== debian/changelog ===
libgc (1:8.2.6-1build1) noble; urgency=high

  * No change rebuild for 64-bit time_t and frame pointers.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 08 Apr 2024 18:03:52 +0200

libgc (1:8.2.6-1) unstable; urgency=medium

  [ Samuel Thibault ]
  * d/libgc1.symbols: Generalize hurd-i386 into hurd-any.

  [ Ian Wienand ]
  * New upstream version 8.2.6

 -- Ian Wienand <ianw@debian.org>  Mon, 05 Feb 2024 20:57:09 +1100

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Source: libgc
-Maintainer: Christoph Egger <christoph@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Christoph Egger <christoph@debian.org>
 Uploaders: Debian GCC Maintainers <debian-gcc@lists.debian.org>, Ian Wienand <ianw@debian.org>
 Section: libs
 Priority: optional

## libgc 8.2.8

=== debian/changelog ===
libgc (1:8.2.8-1) unstable; urgency=medium

  * New upstream version 8.2.8

 -- Ian Wienand <ianw@debian.org>  Fri, 13 Sep 2024 08:37:02 +1000

libgc (1:8.2.6-2) unstable; urgency=medium

  * Fix debian/watch for github API
  * debian/control: update dependency pkg-config -> pkgconf
  * Add libgc1.lintian-overrides
  * debian: update debheper compat
  * control: add Vcs-browser also
  * control: mark as rootless
  * changelog: remove trailing whitespace

 -- Ian Wienand <ianw@debian.org>  Fri, 21 Jun 2024 10:04:46 +1000

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,16 @@
 Source: libgc
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Christoph Egger <christoph@debian.org>
+Maintainer: Christoph Egger <christoph@debian.org>
 Uploaders: Debian GCC Maintainers <debian-gcc@lists.debian.org>, Ian Wienand <ianw@debian.org>
 Section: libs
 Priority: optional
-Build-Depends: debhelper (>= 11),
- pkg-config,
+Build-Depends: debhelper-compat (= 13),
+ pkgconf,
  pkg-kde-tools
 Standards-Version: 4.5.1
 Homepage: https://www.hboehm.info/gc/
+Vcs-Browser: https://salsa.debian.org/debian/libgc
 Vcs-Git: https://salsa.debian.org/debian/libgc
+Rules-Requires-Root: no
 
 Package: libgc1
 Architecture: any

=== debian/watch ===
version=4
opts="searchmode=plain,\
filenamemangle=s%.*/gc-@ANY_VERSION@.tar.gz%@PACKAGE@-$1.tar.gz%" \
https://api.github.com/repos/ivmai/bdwgc/releases?per_page=50 \
https://github.com/ivmai/bdwgc/releases/download/v?\d[\.\da-zA-Z]*/gc-@ANY_VERSION@.tar.gz

## libgc 8.2.10

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 # Copyright (c) 1996 by Silicon Graphics.  All rights reserved.
 # Copyright (c) 1998 by Fergus Henderson.  All rights reserved.
 # Copyright (c) 2000-2010 by Hewlett-Packard Company.  All rights reserved.
-# Copyright (c) 2010-2021 Ivan Maidanski
+# Copyright (c) 2010-2024 Ivan Maidanski
 ##
 # THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY EXPRESSED
 # OR IMPLIED.  ANY USE IS AT YOUR OWN RISK.
@@ -22,16 +22,16 @@
 #  this will generate gc.sln
 #
 
-cmake_minimum_required(VERSION 3.5)
-
-set(PACKAGE_VERSION 8.2.6)
+cmake_minimum_required(VERSION 3.10)
+
+set(PACKAGE_VERSION 8.2.10)
 # Version must match that in AC_INIT of configure.ac and that in README.
 # Version must conform to: [0-9]+[.][0-9]+[.][0-9]+
 
 # Info (current:revision:age) for the Libtool versioning system.
 # These values should match those in cord/cord.am and Makefile.am.
 set(LIBCORD_VER_INFO    6:1:5)
-set(LIBGC_VER_INFO      6:3:5)
+set(LIBGC_VER_INFO      6:5:5)
 set(LIBGCCPP_VER_INFO   6:0:5)
 
 option(enable_cplusplus "C++ support" OFF)
@@ -138,17 +138,23 @@
 # Output all warnings.
 if (BORLAND)
   # All warnings except for particular ones.
-  add_compile_options(/w /w-pro /w-aus /w-par /w-ccc /w-inl /w-rch)
+  add_compile_options(/w /w-aus /w-ccc /w-inl /w-par /w-pro /w-rch /w-use)
 elseif (MSVC)
   # All warnings but ignoring "unreferenced formal parameter" and
   # "conditional expression is constant" ones.
   add_compile_options(/W4 /wd4100 /wd4127)
 elseif (WATCOM)
   add_compile_options(/wx)
-  if (NOT enable_threads)
-    # Suppress "unreachable code" warning in GC_ASSERT(I_HOLD_LOCK()).
+  if (enable_gc_assertions)
+    # Suppress "unreachable code" warning in GC_ASSERT() if some constant
+    # non-zero expression is given as the argument.
     add_compile_options(/wcd=201)
   endif()
+  if (enable_threads)
+    # Suppress "missing return value" wcc warning for AO_test_and_set_full()
+    # and AO_char_fetch_and_add_full() in AO msftc/x86.h file.
+    add_compile_options($<$<COMPILE_LANGUAGE:C>:/wcd=107>)
+  endif(enable_threads)
 else()
   # TODO add -[W]pedantic -Wno-long-long
   add_compile_options(-Wall -Wextra)
@@ -191,6 +197,12 @@
   else()
     set(THREADDLLIBS_LIST ${THREADDLLIBS_LIST} ${CMAKE_DL_LIBS})
   endif()
+  if (BORLAND)
+    # Workaround "cannot locate assembly file" and "out of hash space"
+    # compilation errors, "restarting compile using assembly" warning.
+    add_definitions("-DAO_NO_ASM_XADD")
+    add_definitions("-DAO_NO_ASM_XCHG")
+  endif()
 endif(enable_threads)
 
 set(ATOMIC_OPS_LIBS "") # TODO: Assume libatomic_ops library is not needed.
@@ -297,20 +309,3 @@
 endif()
 
 if (enable_gc_debug)
-  add_definitions("-DDBG_HDRS_ALL -DKEEP_BACK_PTRS")
-  if (HOST MATCHES i.86-.*-dgux.*|ia64-.*-linux.*|i586-.*-linux.*|i686-.*-linux.*|x86-.*-linux.*|x86_64-.*-linux.*)
-    add_definitions("-DMAKE_BACK_GRAPH")
-    if (HOST MATCHES .*-.*-.*linux.*)
-      add_definitions("-DSAVE_CALL_COUNT=8")
-    endif()
-    set(SRC ${SRC} backgraph.c)
-  endif()
-endif(enable_gc_debug)
-
-if (disable_gc_debug)
-  add_definitions("-DNO_DEBUGGING")
-elseif (WINCE)
-  # Read environment variables from "<program>.gc.env" file.
-  add_definitions("-DGC_READ_ENV_FILE")
-endif()
-

=== debian/changelog ===
libgc (1:8.2.10-1) unstable; urgency=medium

  * New upstream version 8.2.10
  * Update debian/watch
  * Update homepage link to github
  * Update standards version

 -- Ian Wienand <ianw@debian.org>  Mon, 20 Oct 2025 20:57:29 +1100

=== debian/control ===
--- 
+++ 
@@ -6,8 +6,8 @@
 Build-Depends: debhelper-compat (= 13),
  pkgconf,
  pkg-kde-tools
-Standards-Version: 4.5.1
-Homepage: https://www.hboehm.info/gc/
+Standards-Version: 4.7.2.0
+Homepage: https://github.com/bdwgc/bdwgc
 Vcs-Browser: https://salsa.debian.org/debian/libgc
 Vcs-Git: https://salsa.debian.org/debian/libgc
 Rules-Requires-Root: no

=== debian/rules ===
#!/usr/bin/make -f

DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_BUILD_ARCH ?=$(shell dpkg --print-architecture)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

LDFLAGS += -pthread

%:
	dh $@ --with pkgkde_symbolshelper,autoreconf

COMMON_CONFIG = $(CONFIG_OPTS) \
		--enable-cplusplus \
		--enable-docs \
		--disable-dependency-tracking \
		--with-tags=CXX \
		--prefix=/usr \
		--mandir=\$${prefix}/share/man \
		--sysconfdir=/etc \
		--localstatedir=/var/lib \
		--datadir=\$${prefix}/share/doc \
		--host=$(DEB_HOST_GNU_TYPE) \
		--build=$(DEB_BUILD_GNU_TYPE) \
		--libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH) \
		--with-libatomic-ops=none

# --enable-static also disables building with symbol-visibility
# attributes, so build the static and dynamic libraries separately to
# ensure the .so symbols are correctly exported.
override_dh_auto_configure:
	[ ! -d libatomic_ops-1.2 ] || mv libatomic_ops-1.2 libatomic_ops-1.2.bak
	mkdir build-dynamic
	cd build-dynamic; ../configure \
		$(COMMON_CONFIG) \
		--enable-shared \
		--disable-static
	mkdir build-static
	cd build-static; ../configure \
		$(COMMON_CONFIG) \
		--enable-static \
		--disable-shared

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_test:
	cd build-dynamic; $(MAKE) check
endif

override_dh_auto_build:
	dh_auto_build -B build-dynamic
	dh_auto_build -B build-static

override_dh_auto_install:
	dh_auto_install -B build-dynamic
	dh_auto_install -B build-static

override_dh_install:
	install -D doc/gc.man debian/tmp/usr/share/man/man3/gc_malloc.3
	dh_install
	rm debian/libgc-dev/usr/share/doc/libgc1/README.environment

override_dh_auto_clean:
	dh_auto_clean
	rm -rf autom4te.cache build-static build-dynamic

override_dh_installchangelogs:
	dh_installchangelogs ChangeLog

=== debian/watch ===
Version: 5
Source: https://api.github.com/repos/bdwgc/bdwgc/git/matching-refs/tags/v
Matching-Pattern: https://api.github.com/repos/[^/]+/[^/]+/git/refs/tags/@ANY_VERSION@
Download-Url-Mangle: s%(api.github.com/repos/[^/]+/[^/]+)/git/refs/%$1/tarball/refs/%g
Filename-Mangle: s%.*/@ANY_VERSION@%gc-$1.tar.gz%
Searchmode: plain

## libgc 8.2.12

=== debian/changelog ===
libgc (1:8.2.12-1) unstable; urgency=medium

  * New upstream version 8.2.12 (Closes: #1125780)

 -- Ian Wienand <ianw@debian.org>  Sat, 07 Feb 2026 07:59:42 +1100
